﻿using Microsoft.AspNetCore.Razor.Runtime.TagHelpers;
using Microsoft.AspNetCore.Razor.TagHelpers;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace TagHelpersTutorial.Helpers
{
    [HtmlTargetElement("login-form")]
    public class LoginTagHelper : TagHelper
    {
        const string UserIdAttributeName = "userId-binding";
        const string PwdAttributeName = "password-binding";
       
        const string ActionAttributeName = "action";

        [HtmlAttributeName(UserIdAttributeName)]
        public string UserId { get; set; }

        [HtmlAttributeName(PwdAttributeName)]
        public string Password { get; set; }

        [HtmlAttributeName(ActionAttributeName)]
        public string Action { get; set; }
        public override void Process(TagHelperContext context, TagHelperOutput output)
        {
            output.TagName ="";
            StringBuilder sb = new StringBuilder();
            string str = string.Format(@"<form method=""post"" class=""form-signin"" action=""{0}"" >
            <h2 class=""form-signin-heading"">Please sign in</h2>
            <input type = ""email"" id=""txtEmail"" name=""{1}""  class=""form-control"" placeholder=""Email Address"" required autofocus>          
            <input type = ""password"" id=""txtPwd"" name=""{2}"" class=""form-control"" placeholder=""Password"" required>
            <button class=""btn btn-lg btn-primary btn-block"" type=""submit"">Sign in</button>
            </form>", Action, UserId, Password);
            sb.Append(str);

            output.Content.AppendHtml(sb.ToString());

        }
    }

    [HtmlTargetElement("tag-name")]
    public class CustomTagHelper:TagHelper
    {
        [HtmlAttributeName("attribute-name")]
        public string propertyname { get; set; }
        public override void Process(TagHelperContext context, TagHelperOutput output)
        {
             base.Process(context, output);  
        }
    }
}

[HtmlTargetElement(Attributes ="citation")]
public class CitationTagHelper:TagHelper
{
    public override void Process(TagHelperContext context, TagHelperOutput output)
    {
        output.Attributes.RemoveAll("citation");
        output.PreContent.SetHtmlContent("<cite>");
        output.PostContent.SetHtmlContent("</cite>");
    }
}
